#include "XMF_OLED096_CC2530.h"
#include "XMF_OLED_Font.h"
#include "XMF_OLED_BMP.h"

/*==========================ʱ==========================*/
void Delay_oled(unsigned char time)
{
  while(time--);
}

/*==========================дֽ==========================*/
void OLED_Write_Byte(unsigned char dat, unsigned char cmd)
{
  unsigned char i;			  
  if(cmd)
    OLED_DC = 1;
  else 
    OLED_DC = 0;	
  
  for(i = 0; i < 8; i++)
  {			  
    OLED_SCK = 0;
    if(dat & 0x80)
      OLED_DD = 1;
    else
      OLED_DD = 0;
    
    OLED_SCK = 1;
    dat<<=1;   
  }				 		  
  OLED_DC = 1;
}

/*====================================================*/
void OLED_Set_Pos(unsigned char x, unsigned char y) 
{ 
  OLED_Write_Byte(0xb0+y, OLED_CMD);
  OLED_Write_Byte(((x&0xf0)>>4)|0x10, OLED_CMD);
  OLED_Write_Byte((x&0x0f)|0x01, OLED_CMD); 
} 

/*==========================ʾַ===========================
* ָλʾһַ,ַ
* x:  0~127
* y:  0~63
* mode:  0--ʾ;  1--ʾ				 
* size:  ѡ 16/12 
=============================================================*/
void OLED_Show_Char(unsigned char x, unsigned char y, unsigned char chr)
{      	
  unsigned char c=0,i=0;	
  c = chr-' ';            //õƫƺֵ			
  if(x > Max_Column-1)
  {
    x = 0;
    y= y + 2;
  }
  if(SIZE ==16)
  {
    OLED_Set_Pos(x, y);	
    for(i = 0; i < 8; i++)
      OLED_Write_Byte(F8X16[c*16+i], OLED_DATA);
    OLED_Set_Pos(x, y+1);
    for(i = 0; i < 8; i++)
      OLED_Write_Byte(F8X16[c*16+i+8],OLED_DATA);
  }
  else {	
    OLED_Set_Pos(x, y+1);
    for(i = 0; i < 6; i++)
      OLED_Write_Byte(F6x8[c][i], OLED_DATA);			
  }
}

/*========================ʾַ==========================*/
void OLED_Show_Str(unsigned char x, unsigned char y, unsigned char *chr)
{
  unsigned char j = 0;
  while (chr[j]!='\0')
  {		
    OLED_Show_Char(x, y, chr[j]);
    x += 8;
    if(x > 120)
    {
      x=0;
      y+=2;
    }
    j++;
  }
}

/*==========================m^n===========================*/
unsigned int OLED_pow(unsigned char m, unsigned char n)
{
  unsigned int result = 1;	 
  while(n--)
    result *= m;    
  return result;
}				  
//ʾ2
//x,y :	 
//len :ֵλ
//size:С
//mode:ģʽ	0,ģʽ;1,ģʽ
//num:ֵ(0~4294967295);	
/*========================ʾλ========================
* ʾλ
* ʼ(x,y)
* num:  ʾ
* len :ֵλ
* size2: С16		 
=============================================================*/
void OLED_Show_Int(unsigned char x, unsigned char y, unsigned int num, unsigned char len, unsigned char size2)
{         	
  unsigned char i,temp;
  unsigned char enshow=0;						   
  for(i = 0; i < len; i++)
  {
    temp=(num/OLED_pow(10,len-i-1))%10;
    if(enshow==0&&i<(len-1))
    {
      if(temp==0)
      {
        OLED_Show_Char(x+(size2/2)*i,y,' ');
        continue;
      }
      else 
        enshow=1; 
		 	 
    }
    OLED_Show_Char(x+(size2/2)*i,y,temp+'0'); 
  }
} 
/*==========================ʾ==========================*/
void OLED_Show_CHN(unsigned char x, unsigned char y, unsigned char no)
{      			    
    unsigned char i,adder = 0;
    OLED_Set_Pos(x, y);	
    for(i = 0; i < 16; i++)
    {
      OLED_Write_Byte(Hzk[2*no][i], OLED_DATA);
      adder += 1;
    }	
    OLED_Set_Pos(x,y+1);	
    for(i = 0; i < 16; i++)
    {	
      OLED_Write_Byte(Hzk[2*no+1][i], OLED_DATA);
      adder += 1;
      }					
}

/*==========================ʾͼƬ==========================
* ʾBMPͼƬ12864
* ʼ(x,y)
* x:  Χ0128
* y: ҳķΧ08			 
=============================================================*/
void OLED_Draw_BMP(unsigned char x0, unsigned char y0,unsigned char x1, unsigned char y1)
{ 	
  unsigned int j=0;
  unsigned char x,y;
  
  if(y1%8 == 0) 
    y = y1/8;      
  else 
    y = y1/8 + 1;
  for(y = y0 ;y < y1; y++)
  {
    OLED_Set_Pos(x0,y);
    for(x = x0; x < x1; x++)
    {      
      OLED_Write_Byte(BMP[j++],OLED_DATA);	    	
    }
  }
} 

/*==========================Ļ==========================*/
void OLED_Clear()  
{  
  unsigned char i,n;		    
  for(i = 0; i < 8; i++)  
  {  
    OLED_Write_Byte(0xb0+i, OLED_CMD);  //ҳַ0~7
    OLED_Write_Byte(0x00, OLED_CMD);    //ʾλáе͵ַ
    OLED_Write_Byte(0x10, OLED_CMD);    //ʾλáиߵַ   
    for(n=0;n<128;n++)
      OLED_Write_Byte(0,OLED_DATA);        //ʾ
  } 
}

/*=======================ʼSSD1306========================*/			    
void OLED_Init()
{
  OLED_RST = 1;
  Delay_oled(100);
  OLED_RST = 0;
  Delay_oled(100);
  OLED_RST = 1;
  
  OLED_Write_Byte(0xAE, OLED_CMD);    //--turn off oled panel
  OLED_Write_Byte(0x00, OLED_CMD);    //---set low column address
  OLED_Write_Byte(0x10, OLED_CMD);    //---set high column address
  OLED_Write_Byte(0x40, OLED_CMD);    //--set start line address  Set Mapping RAM Display Start Line (0x00~0x3F)
  OLED_Write_Byte(0x81, OLED_CMD);    //--set contrast control register
  OLED_Write_Byte(0xCF, OLED_CMD);    // Set SEG Output Current Brightness
  OLED_Write_Byte(0xA1, OLED_CMD);    //--Set SEG/Column Mapping     0xa0ҷ 0xa1
  OLED_Write_Byte(0xC8, OLED_CMD);    //Set COM/Row Scan Direction   0xc0· 0xc8
  OLED_Write_Byte(0xA6, OLED_CMD);    //--set normal display
  OLED_Write_Byte(0xA8, OLED_CMD);    //--set multiplex ratio(1 to 64)
  OLED_Write_Byte(0x3f, OLED_CMD);    //--1/64 duty
  OLED_Write_Byte(0xD3, OLED_CMD);    //-set display offset	Shift Mapping RAM Counter (0x00~0x3F)
  OLED_Write_Byte(0x00, OLED_CMD);    //-not offset
  OLED_Write_Byte(0xd5, OLED_CMD);    //--set display clock divide ratio/oscillator frequency
  OLED_Write_Byte(0x80, OLED_CMD);    //--set divide ratio, Set Clock as 100 Frames/Sec
  OLED_Write_Byte(0xD9, OLED_CMD);    //--set pre-charge period
  OLED_Write_Byte(0xF1, OLED_CMD);    //Set Pre-Charge as 15 Clocks & Discharge as 1 Clock
  OLED_Write_Byte(0xDA, OLED_CMD);    //--set com pins hardware configuration
  OLED_Write_Byte(0x12, OLED_CMD);
  OLED_Write_Byte(0xDB, OLED_CMD);    //--set vcomh
  OLED_Write_Byte(0x40, OLED_CMD);    //Set VCOM Deselect Level
  OLED_Write_Byte(0x20, OLED_CMD);    //-Set Page Addressing Mode (0x00/0x01/0x02)
  OLED_Write_Byte(0x02, OLED_CMD);    
  OLED_Write_Byte(0x8D, OLED_CMD);    //--set Charge Pump enable/disable
  OLED_Write_Byte(0x14, OLED_CMD);    //--set(0x10) disable
  OLED_Write_Byte(0xA4, OLED_CMD);    // Disable Entire Display On (0xa4/0xa5)
  OLED_Write_Byte(0xA6, OLED_CMD);    // Disable Inverse Display On (0xa6/a7) 
  OLED_Write_Byte(0xAF, OLED_CMD);    //--turn on oled panel
	
  OLED_Write_Byte(0xAF,OLED_CMD); /*display ON*/ 
  OLED_Clear();
  OLED_Set_Pos(0,0); 	
} 

/*=======================OLEDʾ=========================*/
void OLED_Display_On()
{
  OLED_Write_Byte(0x8D, OLED_CMD);  //SET DCDC
  OLED_Write_Byte(0x14, OLED_CMD);  //DCDC ON
  OLED_Write_Byte(0xAF, OLED_CMD);  //DISPLAY ON
}

/*=======================رOLEDʾ=========================*/
void OLED_Display_Off()
{
  OLED_Write_Byte(0x8D, OLED_CMD);  //SET DCDC
  OLED_Write_Byte(0x10, OLED_CMD);  //DCDC OFF
  OLED_Write_Byte(0xAE, OLED_CMD);  //DISPLAY OFF
}

/*=============ʼӲ˿ڣֲʱҪ޸ģ===============*/
void Init_OLED_Port()
{
  P1SEL &= ~0xe0;   //P1.5,P1.6,P1.7ΪͨI/O˿ 
  P1DIR |= 0xe0;    //P1.5,P1.6,P1.7Ϊʽ

  P2SEL &= ~0x01;   //P2.0ΪͨI/O˿
  P2DIR |= 0x01;    //P2.0Ϊʽ
  
}